unit fmain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, sqlite3ds,
  db, DBGrids, StdCtrls, FileUtil;

type

  { TForm1 }

  TForm1 = class(TForm)
    AddButton: TButton;
    AddPhoneButton: TButton;
    SearchEdit: TEdit;
    DeletePhoneButton: TButton;
    PhonesGrid: TDBGrid;
    PhonesDatasource: TDatasource;
    DeleteButton: TButton;
    ContactsDataset: TSqlite3Dataset;
    ContactsDataSource: TDatasource;
    ContactsGrid: TDBGrid;
    PhonesDataset: TSqlite3Dataset;
    procedure AddButtonClick(Sender: TObject);
    procedure AddPhoneButtonClick(Sender: TObject);
    procedure ContactsDatasetBeforeDelete(DataSet: TDataSet);
    procedure DeleteButtonClick(Sender: TObject);
    procedure DeletePhoneButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SearchEditChange(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  Form1: TForm1; 

implementation

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  ForceDirectoriesUTF8(GetAppConfigDirUTF8(False));
  with ContactsDataset do
  begin
    FileName := IncludeTrailingPathDelimiter(GetAppConfigDirUTF8(False)) + 'data.db';
    if not TableExists then
    begin
      FieldDefs.Clear;
      FieldDefs.Add('Id', ftAutoInc);
      FieldDefs.Add('Name', ftString);
      FieldDefs.Add('Email', ftString);
      CreateTable;
    end;
    Open;
  end;
  with PhonesDataset do
  begin
    FileName := IncludeTrailingPathDelimiter(GetAppConfigDirUTF8(False)) + 'data.db';
    if not TableExists then
    begin
      FieldDefs.Clear;
      FieldDefs.Add('Id', ftAutoInc);
      FieldDefs.Add('Phone', ftString);
      FieldDefs.Add('ParentId', ftInteger);
      CreateTable;
    end;
    Open;
  end;
end;

procedure TForm1.SearchEditChange(Sender: TObject);
var
  SearchText: String;
  Options: TLocateOptions;
begin
  SearchText := Trim(SearchEdit.Text);
  if SearchText = '' then
  begin
    SearchEdit.Color := clWindow;
    Exit;
  end;
    
  Options := [loCaseInsensitive, loPartialKey];

  if ContactsDataset.Locate('Name', SearchText, Options) then
    SearchEdit.Color := clWindow
  else
    SearchEdit.Color := clRed;
end;

procedure TForm1.AddButtonClick(Sender: TObject);
begin
  ContactsDataset.Append;
  ContactsDataset.FieldByName('Name').AsString := 'New Contact';
  ContactsDataset.FieldByName('Email').AsString := 'xxx@yyy.com';
  ContactsDataset.Post;
end;

procedure TForm1.AddPhoneButtonClick(Sender: TObject);
begin
  PhonesDataset.Append;
  PhonesDataset.Post;
end;

procedure TForm1.ContactsDatasetBeforeDelete(DataSet: TDataSet);
begin
  while not PhonesDataset.IsEmpty do
    PhonesDataset.Delete;
end;

procedure TForm1.DeleteButtonClick(Sender: TObject);
begin
  if ContactsDataset.RecordCount > 0 then
    ContactsDataset.Delete;
end;

procedure TForm1.DeletePhoneButtonClick(Sender: TObject);
begin
  if not PhonesDataset.IsEmpty then
    PhonesDataset.Delete;
end;

initialization
  {$I fmain.lrs}

end.

